/*
 * ble_whts.c
 *
 *  Created on: Dec 16, 2015
 *      Author: C9917732
 */

#include "ble_whts.h"


// 021849a0-b8ac-11e5-a378-0002a5d5c51b
static const ble_uuid128_t m_base_uuid128 = { { 0x1b, 0xc5, 0xd5, 0xa5, 0x02, 0x00, 0x78, 0xa3,
        0xe5, 0x11, 0xac, 0xb8, 0xa0, 0x49, 0x18, 0x02 } };


static uint32_t whts_measurement_sensor_char_add(ble_whts_t* p_whts,
                                                 const ble_whts_init_t* p_whts_init)
{
    uint32_t err_code = 0;

    // TODO

    return err_code;
}

static uint32_t whts_led_ctrl_char_add(ble_whts_t* p_whts,
                                       const ble_whts_init_t* p_whts_init)
{
    uint32_t err_code = 0;

    // TODO

    return err_code;
}

uint32_t ble_whts_init(ble_whts_t* p_whts, const ble_whts_init_t* p_whts_init)
{
	uint32_t err_code;
	ble_uuid_t whts_uuid;

	// Add service
	//   add custom base UUID
	//
	err_code = sd_ble_uuid_vs_add(&m_base_uuid128, &p_whts->uuid_type);

	if (NRF_SUCCESS == err_code)
	{
	    whts_uuid.type = p_whts->uuid_type;
	    whts_uuid.uuid = BLE_UUID_WHTS_SERVICE;

	    err_code = sd_ble_gatts_service_add(BLE_GATTS_SRVC_TYPE_PRIMARY,
	                                        &whts_uuid,
	                                        &p_whts->service_handle);
	    if (NRF_SUCCESS == err_code)
	    {
	        // Add measurement characteristic
	        //
	        err_code = whts_measurement_sensor_char_add(p_whts, p_whts_init);

	        if (NRF_SUCCESS == err_code)
	        {
	            err_code = whts_led_ctrl_char_add(p_whts, p_whts_init);
	        }
	    }
	}

	return err_code;
}
